# Mail Analytics Service

Service for tracking email delivery, bounces, openings and clicks. 

Mail is delivered by the **mail-delivery-service** thru AWS SES. After sending an email, SES will send a webhook with the email delivery status. SES may not send the email if it has incorrect data. It will also send a webhook in case the email bounces (the mailbox doesn't exist). 

The **mail-delivery-service** also puts a tracking pixel in each email. The analytics service serves those images and tracks them in the DB. Also it changes all the links in the email pointing them to this service. When someone clicks on a link on an email, their browser is directed to this web service which tracks the click and redirects the user's browser to the actual link.

### Tasks

- [ ] API endpoint for receiving webhooks for success in mail delivery 
- [ ] API endpoint for receiving webhooks for failure in mail delivery 
- [ ] API endpoint for receiving webhooks for bounced emails
- [X] endpoint for serving the tracking pixel image
- [X] update email data in database for tracking pixel image
- [X] endpoint for redirecting links
- [X] update email data in database for tracked links
